<?php

namespace App\Http\Controllers\Auth;

use App\Http\Controllers\Controller;

use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Support\Facades\Auth;

use Illuminate\Support\Facades\Validator;
use Redirect;
use Illuminate\Http\Request;
use Illuminate\Session\SessionManager;
use DB;
use App\Models\User;
use App\Models\Clientes;
use App\Models\Paquetes;
use App\Models\PreAlertas;




use Illuminate\Support\Facades\Hash;


class AuthController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    //Bearer
    protected $redirectTo = "/";

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        //$this->middleware('guest')->except('logout');
    }



    public function register(Request $request)
    {


          $validateData = Validator::make($request->all(), [        
               
                    'name' => ['required', 'string', 'max:255'],
                    'email' => ['required', 'string', 'max:255','unique:users'],
                    'password' => ['required', 'string', 'max:50'],

      
                   ]);

          if($validateData->fails()){

               return response()->json(['errors'=>$validateData->errors()]);

            }

  
          


          $user = User::create([
                'name'=>$request->name,
                'email'=>$request->email,
                'password'=>Hash::make($request->password)

          ]);

          $token = $user->createToken('auth_token')->plainTextToken;

          User::where('email','=',$request->email)
                        ->update([
                                'remember_token' =>$token,

                            ]);
          return response()->json([

                'access_token'=> $token,
                'token_type'=>'Bearer'
          ]);

    }


    public function login(Request $request)
    {
       $credentials = $request->only('email', 'password');


        if(!Auth::attempt($credentials))
         {

              return response()->json([
                    'message'=>'Invalid Login details'
              ],401);


         }
         $user = User::Where("email","=",$request->only('email'))->firstOrFail();
         $token = $user->createToken("auth_token")->plainTextToken;
         return response()->json([

                'access_token'=> $token,
                'token_type'=>'Bearer'
          ]);
    }


    public function getAllCustomers(Request $request)
    {

        return Clientes::select("clie_id","clie_box","clie_nombre","clie_clave")->orderBy('clie_id', 'desc')->get();
    }

    public function getStatusPackages(Request $request)
    {

        $datos =Paquetes::select("paes_id")->where("paqu_id","=",$request->paqu_id)->get();
        return $datos[0]['paes_id'];
    }

    public function updatePackagesGuide(Request $request)
    { 
 
      DB::beginTransaction();
            
            try {


            Paquetes::whereIn('paqu_id_origen',explode(',',$request->paqu_id_origen))
                              ->update([
                                    'paqu_guia' =>$request->paqu_guia,
									'paes_id' =>2,
									'paqu_fecha_embarque' =>DB::raw('now()'),

                              ]);
            DB::commit();
            return response()->json([
                  'success'=> 'Register has been updated.',            

                  ],201);

            }catch (Exception $e) {

                        DB::rollback();
                  
            return response()->json([
                  'error'=> $e->getMessage(),            

            ],401);
      }
     }

    public function insertPaquets(Request $request)
    { 

      DB::beginTransaction();
       
       try {


          Paquetes::create([
                'paqu_wayno'=>$request->paqu_wayno,
                'paqu_tracking_secundario'=>$request->paqu_tracking_secundario,
                'paqu_tracking'=>$request->paqu_tracking,
                'paqu_peso_real'=>$request->paqu_peso,
				'paqu_peso'=>ceil($request->paqu_peso),
                'paqu_fecha_proceso'=>$request->paqu_fecha_proceso,
                'paqu_id_origen'=>$request->paqu_id_origen,
                'clie_id'=>$request->clie_id,
				'clie_coloader_id'=>$request->clie_coloader_id,
				'paqu_cliente'=>$request->paqu_cliente,
				'paqu_maritimo'=>$request->paqu_maritimo,
				'paqu_pies_cubicos'=>$request->paqu_pies_cubicos,

          ]);
          DB::commit();
           return response()->json([
                'success'=> 'Register has been created.',            

              ],201);

      }catch (Exception $e) {

                    DB::rollback();
                 
        return response()->json([
                'error'=> $e->getMessage(),            

          ],401);
      }
    }

    public function updatePaquets(Request $request)
    { 

      DB::beginTransaction();
       
       try {


          Paquetes::whereIn('paqu_id_origen',explode(',',$request->paqu_id_origen))
                        ->update([
                                'paes_id' =>$request->paes_id,

                            ]);
          DB::commit();
           return response()->json([
                'success'=> 'Register has been updated.',            

              ],201);

      }catch (Exception $e) {

                    DB::rollback();
                 
        return response()->json([
                'error'=> $e->getMessage(),            

          ],401);
      }  
    }

    public function insertPreAlerts(Request $request){

       DB::beginTransaction();
       
       try {

            PreAlertas::create([
                'clie_box'=>$request->clie_box,
                'pral_tracking'=>$request->pral_tracking,
                'pral_fecha'=>$request->pral_fecha

          ]);
          DB::commit();
           return response()->json([
                'success'=> 'Register has been created.',            

              ],201);


       }catch (Exception $e) {

                    DB::rollback();
                 
        return response()->json([
                'error'=> $e->getMessage(),            

          ],401);
       }
    }

    public function getPreAlerts(Request $request){

       return PreAlertas::select("clie_box","pral_tracking","pral_fecha")->get();

    }


  


}
