<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;



class ValidateContacForm extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        return [
            //
            'name'=>'required|string|max:50',
            'email'=>'required|email|string|max:50',
            'subject'=>'required|string|max:50',
            'message'=>'required',
        ];
    }

    public function messages(){
        
        return [
            'name.required' => 'El nombre es obligatorio',
            'name.string' => 'El campo debe ser un texto',

            'email.required' => 'El email es obligatorio',
            'email.string' => 'El campo debe ser un texto',
            'email.email' => 'El campo debe contener un correo valido',
            'subject.required' => 'El campo es obligatorio',
            'subject.string' => 'El campo debe ser un texto',
            'message.required' => 'El mensaje es obligatorio',
        ];
    }
}
