<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/


Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

Route::post('/register',[App\Http\Controllers\Auth\AuthController::class, 'register'])->middleware('checkUser');

Route::post('/login',[App\Http\Controllers\Auth\AuthController::class, 'login'])->name("login");

Route::get('/get-all-clients',[App\Http\Controllers\Auth\AuthController::class, 'getAllCustomers'])->middleware('checkUser');

Route::post('/insert-paquetes',[App\Http\Controllers\Auth\AuthController::class, 'insertPaquets'])->middleware('checkUser');


Route::put('/update-paquetes',[App\Http\Controllers\Auth\AuthController::class, 'updatePaquets'])->middleware('checkUser');


Route::post('/get-status-paquetes',[App\Http\Controllers\Auth\AuthController::class, 'getStatusPackages'])->middleware('checkUser');

Route::put('/update-packages-guide',[App\Http\Controllers\Auth\AuthController::class, 'updatePackagesGuide'])->middleware('checkUser');



Route::post('/insert-pre-alerts',[App\Http\Controllers\Auth\AuthController::class, 'insertPreAlerts'])->middleware('checkUser');

Route::get('/get-pre-alerts',[App\Http\Controllers\Auth\AuthController::class, 'getPreAlerts'])->middleware('checkUser');